



//
//  DropDownView.swift
//  下拉菜单
//
//  Created by lf on 16/3/13.
//  Copyright © 2016年 lf. All rights reserved.
//

import UIKit

class DropDownView: UIView {

    var tableView : UITableView?
    
    var dataArray = [String]()
    
    let reusedId = "cell"
    
    weak var dropDownViewDelegate : DropDownViewDelegate?
    var firstCell : UITableViewCell?
    
    let btn = UIButton()
//    星耀榜、亲密榜、财富榜、贵族榜
    var selectTag : Int? {
        didSet {
            if let selectTag = selectTag {
                let indexPath = NSIndexPath(forRow: selectTag, inSection: 0)
                tableView?.selectRowAtIndexPath(indexPath, animated: true, scrollPosition: .None)
                var cell : UITableViewCell? = UITableViewCell()
                cell = tableView?.cellForRowAtIndexPath(indexPath)
                cell?.selectedBackgroundView = UIView(frame: (cell?.frame)!)
                cell?.selectedBackgroundView?.backgroundColor = UIColor.init(red: 255/255.0, green: 255/255.0, blue: 255/255.0, alpha: 77/255.0)
                cell?.textLabel?.highlightedTextColor = UIColor.init(red: 255/255.0, green: 216/255.0, blue: 0, alpha: 1)
            }
        }
    }
    
    init(frame: CGRect, dataArray : [String]) {
        super.init(frame: frame)
        self.dataArray = dataArray
        
        tableView = UITableView(frame: self.bounds, style: .Plain)

        
        tableView?.backgroundColor = UIColor.init(red: 51/255.0, green: 51/255.0, blue: 51/255.0, alpha: 1)

        tableView?.tableFooterView = UIView()
        addSubview(tableView!)
        
        tableView?.delegate = self
        tableView?.dataSource = self
        tableView?.separatorStyle = .None
        
//        let indexPath = NSIndexPath(forRow: selectTag, inSection: 0)
//        tableView?.selectRowAtIndexPath(indexPath, animated: true, scrollPosition: .None)
    }
    
    
    func show() {
        weak var weakself = self
        UIView.animateWithDuration(0.5) { () -> Void in
            weakself?.tableView?.frame.size.height = CGFloat(44 * self.dataArray.count)
        }
    }
    
    func hide() {
        weak var weakself = self
        UIView.animateWithDuration(0.5, animations: { () -> Void in
            weakself?.tableView?.frame.size.height = 0
            }) { (_) -> Void in
                weakself?.removeFromSuperview()
        }
    }

    required init?(coder aDecoder: NSCoder) {
        fatalError("init(coder:) has not been implemented")
    }

}

extension DropDownView : UITableViewDelegate,UITableViewDataSource {
    func tableView(tableView: UITableView, numberOfRowsInSection section: Int) -> Int {
        return self.dataArray.count
    }
    
    func tableView(tableView: UITableView, cellForRowAtIndexPath indexPath: NSIndexPath) -> UITableViewCell {
        
        var cell = tableView.dequeueReusableCellWithIdentifier(reusedId)
        
        if cell == nil {
            cell = UITableViewCell(style: .Default, reuseIdentifier: reusedId)
        }
        
//        if indexPath.row == 0 {
//            firstCell = cell
//        }
        
        let dataItem = self.dataArray[indexPath.row]
        
        cell!.textLabel?.text = dataItem
        cell?.textLabel?.textAlignment = .Center
        cell!.textLabel?.textColor = UIColor.whiteColor()
        cell?.backgroundColor = UIColor(white: 0, alpha: 0.7)
        
        return cell!
    }
    
    func tableView(tableView: UITableView, didSelectRowAtIndexPath indexPath: NSIndexPath) {
        if dropDownViewDelegate != nil {
            dropDownViewDelegate?.selectTag(indexPath.row)
        }
        self.hide()
        let cell = tableView.cellForRowAtIndexPath(indexPath)
        cell?.selectedBackgroundView = UIView(frame: (cell?.frame)!)
        cell?.selectedBackgroundView?.backgroundColor = UIColor.init(red: 255/255.0, green: 255/255.0, blue: 255/255.0, alpha: 77/255.0)
        cell?.textLabel?.highlightedTextColor = UIColor.init(red: 255/255.0, green: 216/255.0, blue: 0, alpha: 1)
    }
    
}

protocol DropDownViewDelegate : class {
    func selectTag(tag : Int)
}

