//
//  ViewController.swift
//  DropDownView
//
//  Created by lf on 16/6/8.
//  Copyright © 2016年 lf. All rights reserved.
//

import UIKit

class ViewController: UIViewController {

    var dropDownView : DropDownView?
    
    let dataArray = ["综合排序", "价格从高到低", "价格从低到高", "信用排序"]
    
    let btn = UIButton()
    
    var isShow : Bool = false  {
        
        didSet {
            rotateTipAnimation()
            
            btn.backgroundColor = UIColor.clearColor()
            btn.frame = CGRectMake(0, 0, UIScreen.mainScreen().bounds.size.width, UIScreen.mainScreen().bounds.size.height)
            btn.addTarget(self, action: #selector(ViewController.hideDropView), forControlEvents: .TouchUpInside)
            if isShow == true {
                view.addSubview(btn)
            } else {
                btn.removeFromSuperview()
            }
        }
    }

    var selectBtn = TitleImageButton()
    
    var tag : Int = 0 {
        didSet {
           selectBtn.setTitle(dataArray[tag], forState: .Normal)
            let titleSize = NSString(string: dataArray[tag]).sizeWithAttributes([NSFontAttributeName : UIFont.systemFontOfSize(18)])
            let selectBtnW = titleSize.width + (selectBtn.currentImage?.size.width)! + 10
            let selectBtnX = (UIScreen.mainScreen().bounds.size.width - selectBtnW) / 2
            
            
            selectBtn.frame = CGRectMake(selectBtnX, 100, selectBtnW, 30)
        }
        
    }

    
    override func viewDidLoad() {
        super.viewDidLoad()
        // Do any additional setup after loading the view, typically from a nib.
        
       
        
        selectBtn.setTitle(dataArray[tag], forState: .Normal)
        selectBtn.setTitleColor(UIColor.whiteColor(), forState: .Normal)
        selectBtn.setImage(UIImage(named: "shixinjiantou"), forState: .Normal)
        selectBtn.imageView?.contentMode = .Center
        selectBtn.titleLabel?.font = UIFont.systemFontOfSize(18)
        selectBtn.adjustsImageWhenHighlighted = false
        
        selectBtn.backgroundColor = UIColor.orangeColor()
        
        tag = 0
        
        selectBtn.addTarget(self, action: #selector(ViewController.selectBtnClick), forControlEvents: .TouchUpInside)
        view.addSubview(selectBtn)
        
        let dropDownViewW : CGFloat = 150
        let dropDownViewX = (UIScreen.mainScreen().bounds.size.width - dropDownViewW) / 2
        let dropDownViewY : CGFloat = CGRectGetMaxY(selectBtn.frame)
        let dropDownViewH : CGFloat = 44 * CGFloat(dataArray.count)
        
        dropDownView = DropDownView(frame: CGRectMake(dropDownViewX, dropDownViewY, dropDownViewW, dropDownViewH), dataArray: dataArray)
        
        dropDownView?.dropDownViewDelegate = self
        
    }

    func hideDropView() {
        
        if isShow == true {
            dropDownView?.hide()
            isShow = false
        }
    }
    
    private func rotateTipAnimation() {
        
        var angle = CGFloat(M_PI)
        angle += isShow ? 0.01 : -0.01
        
        // 在 iOS 的 block 动画中，旋转是默认顺时针，就近原则
        
        UIView.animateWithDuration(1, animations: { () -> Void in
            self.selectBtn.imageView!.transform = CGAffineTransformRotate(self.selectBtn.imageView!.transform, angle)
        }) { (_) -> Void in
            //                self.isSelectBtnAnimation = false
            self.selectBtn.userInteractionEnabled = true
        }
    }
    
    
    
    func selectBtnClick() {
        selectBtn.userInteractionEnabled = false
        if isShow == true {
            dropDownView?.removeFromSuperview()
            dropDownView?.hide()
            isShow = false
        } else {
            dropDownView?.show()
            isShow = true
            view.addSubview(dropDownView!)
        }
    }

}
extension ViewController : DropDownViewDelegate {
    func selectTag(tag: Int) {
        if isShow == true {
            isShow = false
        }
        self.tag = tag
        
        selectBtn.setTitle(dataArray[tag], forState: .Normal)
    }
}
